# -*- coding: Latin1 -*-
"""
    Kundendienstsystem nach
    Barnes/Klling: Objektorientierte Programmierung mit Java
    ws, 2005-12-03
"""

import string
import random

class Eingabeleser:
    """Class Eingabeleser
    liest die Eingabe und gibt sie
    ber die Methode gibEingabe zurck
    """
    
    # Operations
    def __init__(self,prompt = '# '):
        """function __init__        
        returns object of type Eingabeleser
        """
        # Attributes:
        self.prompt = prompt
    
    def gibEingabe(self):
        """function gibEingabe            
        returns String
        """
        eingabe = raw_input(self.prompt)
        eingabe = string.strip(eingabe)
        eingabe = string.lower(eingabe)
        return eingabe

class Beantworter:
    """Class Beantworter: gibt eine
    passende Antwort zurck   
    """
    
    # Operations
    def __init__(self):
        """function __init__        
        returns 
        """
        # Attributes:
        self.antworten = []  # (Liste)     
        self.antwortListeFuellen()
        self.len = len(self.antworten)
    
    def genAntwort(self):
        """function genAntwort       
        returns String
        """
        i = 5
        antwort = self.antworten[i]
        return antwort
    
    def antwortListeFuellen(self):
        """function antwortListeFuellen        
        returns 
        """
        self.antworten.append("Das klingt interessant. Erz\xe4hlen Sie mehr...")
        self.antworten.append("Das klingt seltsam. K\xf6nnen Sie das \nProblem ausf\xfchrlicher beschreiben?")
        self.antworten.append("Das steht im Handbuch! Haben Sie das Handbuch gelesen?")
        self.antworten.append("Das ist kein Fehler! Das geh\xf6rt sich so!")
        self.antworten.append("K\xf6nnten Sie es anders erkl\xe4ren?")
        self.antworten.append("Haben Sie gepr\xfcft, ob es sich um einen DLL-Versionskonflikt handelt?")
        self.antworten.append("Da brauche ich etwas genauere Angaben.")
        self.antworten.append("Bisher hat sich noch nie ein Kunde dar\xfcber beschwert.\n Welche Systemkonfiguration haben Sie?")
        self.antworten.append("Das klingt alles etwas unklar. Haben Sie nicht\n einen Experten in der N\xe4he, der das etwas genauer beschreiben kann?")
        
        
class Kundendienstsystem:
    """Class Kundendienstsystem
    """
    
    # Operations
    def __init__(self):
        """function __init__        
        returns 
        """
        # Attributes:
        self.leser = Eingabeleser('> ')  # (Eingabeleser) 
        self.antworter = Beantworter()  # (Beantworter)
        
    def starten(self):
        """function starten        
        returns %
        """        
        fertig = 0 # False
        self.hallo()
        while (not fertig):
            eingabe = self.leser.gibEingabe()
            if eingabe.startswith('ade'):     
                fertig = 1
            else:
                antwort = self.antworter.genAntwort()
                print antwort
                
        self.ciao()

    
    def ciao(self):
        """function ciao: beendet 'Dialog'        
        returns %
        """
        #print "Vielen Dank! Bis denn . . ."
        print "Vielen Dank, bis zum nchsten Absturz!"
        
    def hallo(self):
        """function hallo: Begrungsdialog
        returns %
        """
        print "Ei gudde wie? Hier >>> Michisoft Ltd & Co KG <<<\n"
        print "Beenden durch Eingabe von 'Ade'!"
        print "Wir sind die Lsung, wo ist das Problem?\n"
        
if  __name__ == '__main__':
    test = Kundendienstsystem()
    test.starten()

