# -*- coding: Latin1 -*-
"""
    Kundendienstsystem nach
    Barnes/Klling: Objektorientierte Programmierung mit Java
    ws, 2006-01-16
"""

import string
import random

class Eingabeleser:
    """Class Eingabeleser
    liest die Eingabe und gibt sie
    ber die Methode gibEingabe zurck
    """
    
    # Operations
    def __init__(self,prompt = '# '):
        """function __init__        
        returns object of type Eingabeleser
        """
        # Attributes:
        self.prompt = prompt
    
    def gibEingabe(self):
        """function gibEingabe            
        returns String
        """
        eingabe = raw_input(self.prompt)
        eingabe = string.strip(eingabe)
        eingabe = string.lower(eingabe)
        return eingabe

class Beantworter:
    """Class Beantworter
    """
    
    # Operations
    def __init__(self):
        """function __init__        
        returns 
        """
        # Attributes:
        self.zufallsgenerator = None  # (Random) 
        self.antworten = []  # (Liste)     
        self.antwortListeFuellen()
    
    def genAntwort(self):
        """function genAntwort       
        returns String
        """
        antwort = "Das klingt interessant. Erzhlen Sie mehr..."
        return antwort
    
    def antwortListeFuellen(self):
        """function antwortListeFuellen        
        returns 
        """
        self.antworten.append("Das klingt interessant. Erz\xe4hlen Sie mehr...")

class diciBeantworter(Beantworter):
    """Class diciBeantworter
    """
    
    # Operations
    def __init__(self):
        """function __init__        
        returns %
        """
        # Attributes:
        self.antworten = {}  # (Dicitonary)     
        self.antwortDiciFuellen()
        
    def eingabe2Liste(self,eingabe):
        """function eingabe2Liste
        in: eingabe
        out: wortliste 
        """        
        import string
        _debug_ = 0
        wortliste = string.split(eingabe) # text in liste
        i = 0
        for wort in wortliste:
            # Zeichen am Ende eines Wortes rauswerfen            
            if wort[len(wort)-1] in [',','!','.','?',':']: 
                wort = wort[:len(wort)-1]
            # falls das '#'-Zeichen (bzw.' oder ")
            # am Anfang eines Wortes 'klebt', entfernen   
            if len(wort) > 1 and wort[0] in ['#','"',"'"]:
                wort = wort[1:len(wort)]
            wortliste[i] = wort
            i = i + 1
        if _debug_:    
            print wortliste
        return wortliste

    
    def genAntwort(self,eingabe=None):
        """function genAntwort
        in: eingabe
        out: antwort 
        """
        antwort = ''
        if eingabe == None:
            antwort = self.antworten["default"]
            
        else:
            wortliste = self.eingabe2Liste(eingabe) # wortliste erzeugen
            print wortliste # Test
            # jetzt im Dictionary self.antworten das passende Statement suchen
        # Was passiert, falls kein Erfolg bei der Suche im Dictionary?
        return antwort
    
    def antwortDiciFuellen(self):
        """function antwortDiciFuellen        
        returns self.antworten
        """
        self.antworten["default"]="Das klingt interessant. Erz\xe4hlen Sie mehr..."        
        self.antworten["pc"]= "Das klingt seltsam. K\xf6nnen Sie das \nProblem ausf\xfchrlicher beschreiben?"
        self.antworten["frage"]= "Das steht im Handbuch! Haben Sie das Handbuch gelesen?"
        self.antworten["fehler"]= "Das ist kein Fehler! Das geh\xf6rt sich so!"
        self.antworten["installiert"]= "Haben Sie gepr\xfcft, ob es sich um einen DLL-Versionskonflikt handelt?"
        self.antworten["kann"]= "Bisher hat sich noch nie ein Kunde dar\xfcber beschwert.\n Welche Systemkonfiguration haben Sie?"
        self.antworten["beschwerde"]= "Bisher hat sich noch nie ein Kunde dar\xfcber beschwert.\n Welche Systemkonfiguration haben Sie?"
        self.antworten["also"]= "K\xf6nnten Sie es anders erkl\xe4ren?"
        self.antworten["karte"]= "Das klingt seltsam. K\xf6nnen Sie das \nProblem ausf\xfchrlicher beschreiben?"
        self.antworten["langsam"]= "Bisher hat sich noch nie ein Kunde dar\xfcber beschwert.\n Welche Systemkonfiguration haben Sie?"
        
        
        
                
        
class Kundendienstsystem:
    """Class Kundendienstsystem
    """
    
    # Operations
    def __init__(self):
        """function __init__        
        returns 
        """
        # Attributes:
        self.leser = Eingabeleser('> ')  # (Eingabeleser) 
        self.antworter = diciBeantworter()  # (Beantworter)
        
    def starten(self):
        """function starten        
        returns %
        """        
        fertig = 0 # False
        self.hallo()
        while (not fertig):
            eingabe = self.leser.gibEingabe()
            if eingabe.startswith('ade'):     
                fertig = 1
            else:
                antwort = self.antworter.genAntwort(eingabe)
                print antwort
                
        self.ciao()

    
    def ciao(self):
        """function ciao: beendet 'Dialog'        
        returns %
        """
        #print "Vielen Dank! Bis denn . . ."
        print "Vielen Dank, bis zum nchsten Absturz!"
        
    def hallo(self):
        """function hallo: Begrungsdialog
        returns %
        """
        print "Ei gudde wie? Hier >>> Michisoft Ltd & Co KG <<<\n"
        print "Beenden durch Eingabe von 'Ade'!"
        print "Wir sind die Lsung, wo ist das Problem?\n"
        
if  __name__ == '__main__':
    test = Kundendienstsystem()
    test.starten()

